//+------------------------------------------------------------------+
//|                                                     Lot Size.mq4 |
//|                                   Copyright 2012, Lonnie Coffman |
//|                                          dropshipsites@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Lonnie Coffman"
#property link      "dropshipsites@gmail.com"
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 0

extern int    GMTOpenHour = 4;
extern int    DailyRangeDays = 5;

extern bool   Erase_Lines_on_Close = true;
extern bool   Display_Day_Start_Line = true;
extern bool   Display_PrevDay_Start_Line = true;
extern bool   Display_PrevWeek_Start_Line = true;
extern bool   Display_PrevWeek_End_Line = true;
extern bool   Display_Big_Figure = true;
extern bool   Display_Mid_Figure = true;
extern bool   Display_Previous_Week_High = true;
extern bool   Display_Previous_Week_Low = true;
extern bool   Display_Previous_Week_Close = true;
extern bool   Display_Daily_Open = true;
extern bool   Display_Previous_Day_Open = true;
extern bool   Display_Previous_Day_Low = true;
extern bool   Display_Previous_Day_High = true;
extern bool   Display_Previous_London_Close = true;
extern bool   Display_Beginning_of_Day = true;

extern int    Extend_Bars_Past_Present = 10;
extern int    Number_of_Figure_Lines = 5; // number of big figure and mid figure lines to show above/below price
extern string Line_Properties =  "---LINE PROPERTIES--------------------";
extern string Line_Properties1 = "Style: 0=Solid, 1=Dash, 2=Dot,";
extern string Line_Properties2 = "          3=DashDot, 4=DashDotDot";
extern string Line_Properties3 = "-------------------------------------------------------";
extern string Past_Levels_Label = "Past Levels";
extern bool   Past_Levels_Active = false;
extern int    Past_Levels_Width = 1;
extern int    Past_Levels_Style = STYLE_DOT;
extern color  Past_Levels_Color = PowderBlue;
extern string Big_Figure_Label = "Big Figure";
extern int    Big_Figure_Width = 1;
extern int    Big_Figure_Style = STYLE_DOT;
extern color  Big_Figure_Color = C'40,40,40';
extern string Mid_Figure_Label = "Mid Figure";

extern int    Mid_Figure_Width = 1;
extern int    Mid_Figure_Style = STYLE_DOT;
extern color  Mid_Figure_Color = C'40,40,40';
extern string Previous_Week_High_Label = "Previous Week High";

extern int    Previous_Week_High_Width = 1;
extern int    Previous_Week_High_Style = STYLE_SOLID;
extern color  Previous_Week_High_Color = Purple;
extern string Previous_Week_Low_Label = "Previous Week Low";

extern int    Previous_Week_Low_Width = 1;
extern int    Previous_Week_Low_Style = STYLE_SOLID;
extern color  Previous_Week_Low_Color = Purple;
extern string Previous_Week_Close_Label = "Previous Week Close";

extern int    Previous_Week_Close_Width = 1;
extern int    Previous_Week_Close_Style = STYLE_SOLID;
extern color  Previous_Week_Close_Color = Purple;
extern string Daily_Open_Label = "Daily Open";

extern int    Daily_Open_Width = 1;
extern int    Daily_Open_Style = STYLE_SOLID;
extern color  Daily_Open_Color = Green;
extern string Previous_Day_Open_Label = "Previous Day Open";

extern int    Previous_Day_Open_Width = 1;
extern int    Previous_Day_Open_Style = STYLE_SOLID;
extern color  Previous_Day_Open_Color = Green;
extern string Previous_Day_Low_Label = "Previous Day Low";

extern int    Previous_Day_Low_Width = 1;
extern int    Previous_Day_Low_Style = STYLE_SOLID;
extern color  Previous_Day_Low_Color = Green;
extern string Previous_Day_High_Label = "Previous Day High";

extern int    Previous_Day_High_Width = 1;
extern int    Previous_Day_High_Style = STYLE_SOLID;
extern color  Previous_Day_High_Color = Green;
extern string Previous_London_Close_Label  = "London Close";

extern int    Previous_London_Close_Width  = 1;
extern int    Previous_London_Close_Style  = STYLE_DOT;
extern color  Previous_London_Close_Color  = DarkGoldenrod;
extern string Beginning_of_Day_Label  = "Beginning of Day";

extern int    Beginning_of_Day_Width  = 1;
extern int    Beginning_of_Day_Style  = STYLE_SOLID;
extern color  Beginning_of_Day_Color  = DarkOliveGreen;



IndicatorShortName("");

double BeginningOfDayData[2];
double DailyOpenData[2];
double PreviousDayOpenData[2];
double PreviousDayHighData[2];
double PreviousDayLowData[2];
double PreviousWeekHighData[2];
double PreviousWeekLowData[2];
double PreviousWeekOpenData[2];
double PreviousWeekCloseData[2];
double LondonCloseData[2];
double PastLevels[4];

double Percent15, Percent20, Percent25;
int a;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("BarEnd");
   ObjectDelete("Spread");
   ObjectDelete("SpreadLabel");
   ObjectDelete("AvgSpread");
   ObjectDelete("DailyRange");
   ObjectDelete("DailyRangeDays");
   
   ObjectDelete("ATR15");
   ObjectDelete("ATR15_Value");
   ObjectDelete("ATR20");
   ObjectDelete("ATR20_Value");
   ObjectDelete("ATR25");
   ObjectDelete("ATR25_Value");
   
   ObjectDelete("TradeValues");
   ObjectDelete("StopSize");
   ObjectDelete("ProfitSize");
   ObjectDelete("TradeRatio");
   ObjectDelete("OnePercent");
   ObjectDelete("TwoPercent");
   
   ObjectDelete("EntryLine");
   ObjectDelete("EntryLabel");
   ObjectDelete("StopLine");
   ObjectDelete("StopLabel");
   ObjectDelete("ProfitLine");
   ObjectDelete("ProfitLabel");
   
   if (Erase_Lines_on_Close == true){
      a = 1;
      ObjectDelete(Mid_Figure_Label+" 0");
      while(a <= (Number_of_Figure_Lines * 2)){
         ObjectDelete(Big_Figure_Label+" "+DoubleToStr(a,0));
         ObjectDelete(Mid_Figure_Label+" "+DoubleToStr(a,0));
         a++;
      }
      ObjectDelete(Beginning_of_Day_Label);
      ObjectDelete("Start of Previous Day");
      ObjectDelete("Start of Previous Week");
      ObjectDelete("End of Previous Week");
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   double EntryLinePrice1;
   datetime EntryLineTime1;
   double EntryLineLevel,StopLineLevel,ProfitLineLevel,StopPips,ProfitPips,RatioPips,OnePercentLot,TwoPercentLot,OnePercentMargin,TwoPercentMargin;
   double CurEntryLine = ObjectGet("EntryLine",OBJPROP_PRICE1);
   double CurStopLine = ObjectGet("StopLine",OBJPROP_PRICE1);
   double CurProfitLine = ObjectGet("ProfitLine",OBJPROP_PRICE1);
   
   int ExtendBars = (Time[0] + (Extend_Bars_Past_Present * 60 * Period()));
   
   CalculateLevels(Symbol(),Period());
   
   // Draw figure lines
   if ((Number_of_Figure_Lines > 0)&&((Display_Big_Figure == true)||(Display_Mid_Figure == true))){
      DrawFigures(Symbol(), Number_of_Figure_Lines);
   }
   
   if (Display_Day_Start_Line == true)       DrawLine(Symbol(), OBJ_VLINE, Beginning_of_Day_Label, BeginningOfDayData[0], 0, 0, 0, Beginning_of_Day_Style, Beginning_of_Day_Color, Beginning_of_Day_Width);
   if (Display_PrevDay_Start_Line == true)   DrawLine(Symbol(), OBJ_VLINE, "Start of Previous Day", PreviousDayOpenData[0], 0, 0, 0, Previous_Day_Open_Style, Beginning_of_Day_Color, Previous_Day_Open_Width);
   if (Display_PrevWeek_Start_Line == true)  DrawLine(Symbol(), OBJ_VLINE, "Start of Previous Week", PreviousWeekOpenData[0], 0, 0, 0, Previous_Week_Close_Style, Previous_Week_Close_Color, Previous_Week_Close_Width);
   if (Display_PrevWeek_End_Line == true)    DrawLine(Symbol(), OBJ_VLINE, "End of Previous Week", PreviousWeekCloseData[0], 0, 0, 0, Previous_Week_Close_Style, Previous_Week_Close_Color, Previous_Week_Close_Width);
   if (Display_Daily_Open == true)           DrawLine(Symbol(), OBJ_TREND, Daily_Open_Label, DailyOpenData[0], DailyOpenData[1], ExtendBars, DailyOpenData[1], Daily_Open_Style, Daily_Open_Color, Daily_Open_Width);
   if (Display_Previous_Day_High == true)    DrawLine(Symbol(), OBJ_TREND, Previous_Day_High_Label, PreviousDayHighData[0], PreviousDayHighData[1], ExtendBars, PreviousDayHighData[1], Previous_Day_High_Style, Previous_Day_High_Color, Previous_Day_High_Width);
   if (Display_Previous_Day_Low == true)     DrawLine(Symbol(), OBJ_TREND, Previous_Day_Low_Label, PreviousDayLowData[0], PreviousDayLowData[1], ExtendBars, PreviousDayLowData[1], Previous_Day_Low_Style, Previous_Day_Low_Color, Previous_Day_Low_Width);
   if (Display_Previous_Week_Close == true)  DrawLine(Symbol(), OBJ_TREND, Previous_Week_Close_Label, PreviousWeekCloseData[0], PreviousWeekCloseData[1], ExtendBars, PreviousWeekCloseData[1], Previous_Week_Close_Style, Previous_Week_Close_Color, Previous_Week_Close_Width);
   if (Display_Previous_Week_High == true)   DrawLine(Symbol(), OBJ_TREND, Previous_Week_High_Label, PreviousWeekHighData[0], PreviousWeekHighData[1], ExtendBars, PreviousWeekHighData[1], Previous_Week_High_Style, Previous_Week_High_Color, Previous_Week_High_Width);
   if (Display_Previous_Week_Low == true)    DrawLine(Symbol(), OBJ_TREND, Previous_Week_Low_Label, PreviousWeekLowData[0], PreviousWeekLowData[1], ExtendBars, PreviousWeekLowData[1], Previous_Week_Low_Style, Previous_Week_Low_Color, Previous_Week_Low_Width);
   if (Display_Previous_London_Close == true)DrawLine(Symbol(), OBJ_TREND, Previous_London_Close_Label, LondonCloseData[0]-1, LondonCloseData[1], ExtendBars, LondonCloseData[1], Previous_London_Close_Style, Previous_London_Close_Color, Previous_London_Close_Width);
   
   // determine where to place trade level Bars
   if ((WindowPriceMax(0) - Bid) > (Bid - WindowPriceMin(0))){
      ProfitLineLevel = (WindowPriceMax(0) - ((WindowPriceMax(0) - Bid) * 0.1));
      StopLineLevel =  (WindowPriceMax(0) - ((WindowPriceMax(0) - Bid) * 0.15));
      EntryLineLevel =   (WindowPriceMax(0) - ((WindowPriceMax(0) - Bid) * 0.2));
   } else {
      EntryLineLevel = (((Bid - WindowPriceMin(0)) * 0.1) + WindowPriceMin(0));
      StopLineLevel =  (((Bid - WindowPriceMin(0)) * 0.15) + WindowPriceMin(0));
      ProfitLineLevel =   (((Bid - WindowPriceMin(0)) * 0.2) + WindowPriceMin(0));
   }
//----
   if (ObjectFind("EntryLine") < 0){
      ObjectCreate("EntryLine", OBJ_HLINE, 0, Time[0], EntryLineLevel, 0, 0);
      ObjectSet("EntryLine", OBJPROP_COLOR, C'62,62,62');
      ObjectSet("EntryLine", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("EntryLine", OBJPROP_WIDTH, 1);
   } else { // move line if it exists
      if ( (CurEntryLine > WindowPriceMax(0)) || (CurEntryLine < WindowPriceMin(0)) ){
         ObjectSet("EntryLine", OBJPROP_PRICE1, EntryLineLevel);
      }
   }
   if (ObjectFind("EntryLabel") < 0){
      EntryLinePrice1 = CurEntryLine;
      EntryLineTime1 = iTime(Symbol(),Period(),WindowFirstVisibleBar() - 10); 
      ObjectCreate("EntryLabel", OBJ_TEXT,0,0,0);
      ObjectSetText("EntryLabel","Entry", 8, "Arial", CadetBlue);
      ObjectSet("EntryLabel", OBJPROP_PRICE1, EntryLinePrice1);
      ObjectSet("EntryLabel", OBJPROP_TIME1, EntryLineTime1);
   }
   if ((ObjectFind("EntryLabel") >= 0)&&(ObjectFind("EntryLine") >=0)){
      EntryLinePrice1 = CurEntryLine;
      EntryLineTime1 = iTime(Symbol(),Period(),WindowFirstVisibleBar() - 10);
      ObjectSet("EntryLabel", OBJPROP_PRICE1, EntryLinePrice1);
      ObjectSet("EntryLabel", OBJPROP_TIME1, EntryLineTime1);
   }
   if (ObjectFind("StopLine") < 0){
      ObjectCreate("StopLine", OBJ_HLINE, 0, Time[0], StopLineLevel, 0, 0);
      ObjectSet("StopLine", OBJPROP_COLOR, C'79,0,0');
      ObjectSet("StopLine", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("StopLine", OBJPROP_WIDTH, 1);
   } else { // move line if it exists
      if ( (CurStopLine > WindowPriceMax(0)) || (CurStopLine < WindowPriceMin(0)) ){
         ObjectSet("StopLine", OBJPROP_PRICE1, StopLineLevel);
      }
   }
   if (ObjectFind("StopLabel") < 0){
      EntryLinePrice1 = CurStopLine;
      EntryLineTime1 = iTime(Symbol(),Period(),WindowFirstVisibleBar() - 10); 
      ObjectCreate("StopLabel", OBJ_TEXT,0,0,0);
      ObjectSetText("StopLabel","Stop", 8, "Arial", CadetBlue);
      ObjectSet("StopLabel", OBJPROP_PRICE1, EntryLinePrice1);
      ObjectSet("StopLabel", OBJPROP_TIME1, EntryLineTime1);
   }
   if ((ObjectFind("StopLabel") >= 0)&&(ObjectFind("StopLine") >=0)){
      EntryLinePrice1 = CurStopLine;
      EntryLineTime1 = iTime(Symbol(),Period(),WindowFirstVisibleBar() - 10);
      ObjectSet("StopLabel", OBJPROP_PRICE1, EntryLinePrice1);
      ObjectSet("StopLabel", OBJPROP_TIME1, EntryLineTime1);
   }
   if (ObjectFind("ProfitLine") < 0){
      ObjectCreate("ProfitLine", OBJ_HLINE, 0, Time[0], ProfitLineLevel, 0, 0);
      ObjectSet("ProfitLine", OBJPROP_COLOR, C'0,55,0');
      ObjectSet("ProfitLine", OBJPROP_STYLE, STYLE_DASH);
      ObjectSet("ProfitLine", OBJPROP_WIDTH, 1);
   } else { // move line if it exists
      if ( (CurProfitLine > WindowPriceMax(0)) || (CurProfitLine < WindowPriceMin(0)) ){
         ObjectSet("ProfitLine", OBJPROP_PRICE1, ProfitLineLevel);
      }
   }
   if (ObjectFind("ProfitLabel") < 0){
      EntryLinePrice1 = CurProfitLine;
      EntryLineTime1 = iTime(Symbol(),Period(),WindowFirstVisibleBar() - 10);
      ObjectCreate("ProfitLabel", OBJ_TEXT,0,0,0);
      ObjectSetText("ProfitLabel","Profit", 8, "Arial", CadetBlue);
      ObjectSet("ProfitLabel", OBJPROP_PRICE1, EntryLinePrice1);
      ObjectSet("ProfitLabel", OBJPROP_TIME1, EntryLineTime1);
   }
   if ((ObjectFind("ProfitLabel") >= 0)&&(ObjectFind("ProfitLine") >=0)){
      EntryLinePrice1 = CurProfitLine;
      EntryLineTime1 = iTime(Symbol(),Period(),WindowFirstVisibleBar() - 10);
      ObjectSet("ProfitLabel", OBJPROP_PRICE1, EntryLinePrice1);
      ObjectSet("ProfitLabel", OBJPROP_TIME1, EntryLineTime1);
   }
   if (ObjectFind("DailyRange") < 0){
      ObjectCreate("DailyRange",OBJ_LABEL,1,0,0);
      ObjectSetText("DailyRange","Avg Daily Range: ", 10, "Arial", LightSteelBlue);
      ObjectSet("DailyRange", OBJPROP_CORNER, 0);
      ObjectSet("DailyRange", OBJPROP_XDISTANCE, 24);
      ObjectSet("DailyRange", OBJPROP_YDISTANCE, 5);
   }
   if (ObjectFind("DailyRangeDays") < 0){
      ObjectCreate("DailyRangeDays",OBJ_LABEL,1,0,0);
      ObjectSetText("DailyRangeDays","( )", 8, "Arial", LightSteelBlue);
      ObjectSet("DailyRangeDays", OBJPROP_CORNER, 0);
      ObjectSet("DailyRangeDays", OBJPROP_XDISTANCE, 148);
      ObjectSet("DailyRangeDays", OBJPROP_YDISTANCE, 6);
   }
   if (ObjectFind("Spread") < 0){
      ObjectCreate("Spread",OBJ_LABEL,1,0,0);
      ObjectSetText("Spread","Spread:", 10, "Arial", LightSteelBlue);
      ObjectSet("Spread", OBJPROP_CORNER, 0);
      ObjectSet("Spread", OBJPROP_XDISTANCE, 24);
      ObjectSet("Spread", OBJPROP_YDISTANCE, 28);
   }
   if (ObjectFind("SpreadLabel") < 0){
      ObjectCreate("SpreadLabel",OBJ_LABEL,1,0,0);
      ObjectSetText("SpreadLabel","", 10, "Arial", LightSteelBlue);
      ObjectSet("SpreadLabel", OBJPROP_CORNER, 0);
      ObjectSet("SpreadLabel", OBJPROP_XDISTANCE, 72);
      ObjectSet("SpreadLabel", OBJPROP_YDISTANCE, 28);
   }
   if (ObjectFind("BarEnd") < 0){
      ObjectCreate("BarEnd",OBJ_LABEL,1,0,0);
      ObjectSetText("BarEnd","Bar Ends:", 10, "Arial", LightSteelBlue);
      ObjectSet("BarEnd", OBJPROP_CORNER, 0);
      ObjectSet("BarEnd", OBJPROP_XDISTANCE, 24);
      ObjectSet("BarEnd", OBJPROP_YDISTANCE, 51);
   }
   if (ObjectFind("ATR15") < 0){
      ObjectCreate("ATR15",OBJ_LABEL,1,0,0);
      ObjectSetText("ATR15","ATR 15%: ", 10, "Arial", LightSteelBlue);
      ObjectSet("ATR15", OBJPROP_CORNER, 0);
      ObjectSet("ATR15", OBJPROP_XDISTANCE, 244);
      ObjectSet("ATR15", OBJPROP_YDISTANCE, 5);
   }
   if (ObjectFind("ATR15_Value") < 0){
      ObjectCreate("ATR15_Value",OBJ_LABEL,1,0,0);
      ObjectSetText("ATR15_Value","00", 10, "Arial", MediumTurquoise);
      ObjectSet("ATR15_Value", OBJPROP_CORNER, 0);
      ObjectSet("ATR15_Value", OBJPROP_XDISTANCE, 310);
      ObjectSet("ATR15_Value", OBJPROP_YDISTANCE, 5);
   }
   if (ObjectFind("ATR20") < 0){
      ObjectCreate("ATR20",OBJ_LABEL,1,0,0);
      ObjectSetText("ATR20","ATR 20%: ", 10, "Arial", LightSteelBlue);
      ObjectSet("ATR20", OBJPROP_CORNER, 0);
      ObjectSet("ATR20", OBJPROP_XDISTANCE, 244);
      ObjectSet("ATR20", OBJPROP_YDISTANCE, 28);
   }
   if (ObjectFind("ATR20_Value") < 0){
      ObjectCreate("ATR20_Value",OBJ_LABEL,1,0,0);
      ObjectSetText("ATR20_Value","00", 10, "Arial", MediumTurquoise);
      ObjectSet("ATR20_Value", OBJPROP_CORNER, 0);
      ObjectSet("ATR20_Value", OBJPROP_XDISTANCE, 310);
      ObjectSet("ATR20_Value", OBJPROP_YDISTANCE, 28);
   }
   if (ObjectFind("ATR25") < 0){
      ObjectCreate("ATR25",OBJ_LABEL,1,0,0);
      ObjectSetText("ATR25","ATR 25%: ", 10, "Arial", LightSteelBlue);
      ObjectSet("ATR25", OBJPROP_CORNER, 0);
      ObjectSet("ATR25", OBJPROP_XDISTANCE, 244);
      ObjectSet("ATR25", OBJPROP_YDISTANCE, 51);
   }
   if (ObjectFind("ATR25_Value") < 0){
      ObjectCreate("ATR25_Value",OBJ_LABEL,1,0,0);
      ObjectSetText("ATR25_Value","00", 10, "Arial", MediumTurquoise);
      ObjectSet("ATR25_Value", OBJPROP_CORNER, 0);
      ObjectSet("ATR25_Value", OBJPROP_XDISTANCE, 310);
      ObjectSet("ATR25_Value", OBJPROP_YDISTANCE, 51);
   }
   if (ObjectFind("TradeValues") < 0){
      ObjectCreate("TradeValues",OBJ_LABEL,1,0,0);
      ObjectSetText("TradeValues","TradeValues: ", 11, "Arial", MediumTurquoise);
      ObjectSet("TradeValues", OBJPROP_CORNER, 0);
      ObjectSet("TradeValues", OBJPROP_XDISTANCE, 400);
      ObjectSet("TradeValues", OBJPROP_YDISTANCE, 2);
   }
   if (ObjectFind("TradeRatio") < 0){
      ObjectCreate("TradeRatio",OBJ_LABEL,1,0,0);
      ObjectSetText("TradeRatio","(Invalid)", 8, "Arial", LightSteelBlue);
      ObjectSet("TradeRatio", OBJPROP_CORNER, 0);
      ObjectSet("TradeRatio", OBJPROP_XDISTANCE, 490);
      ObjectSet("TradeRatio", OBJPROP_YDISTANCE, 4);
   }
   if (ObjectFind("StopSize") < 0){
      ObjectCreate("StopSize",OBJ_LABEL,1,0,0);
      ObjectSetText("StopSize","Stop Pips: 0", 10, "Arial", LightSteelBlue);
      ObjectSet("StopSize", OBJPROP_CORNER, 0);
      ObjectSet("StopSize", OBJPROP_XDISTANCE, 405);
      ObjectSet("StopSize", OBJPROP_YDISTANCE, 28);
   }
   if (ObjectFind("ProfitSize") < 0){
      ObjectCreate("ProfitSize",OBJ_LABEL,1,0,0);
      ObjectSetText("ProfitSize","Profit Pips: 0", 10, "Arial", LightSteelBlue);
      ObjectSet("ProfitSize", OBJPROP_CORNER, 0);
      ObjectSet("ProfitSize", OBJPROP_XDISTANCE, 405);
      ObjectSet("ProfitSize", OBJPROP_YDISTANCE, 51);
   }
   if (ObjectFind("OnePercent") < 0){
      ObjectCreate("OnePercent",OBJ_LABEL,1,0,0);
      ObjectSetText("OnePercent","1%: 0", 10, "Arial", MediumTurquoise);
      ObjectSet("OnePercent", OBJPROP_CORNER, 0);
      ObjectSet("OnePercent", OBJPROP_XDISTANCE, 510);
      ObjectSet("OnePercent", OBJPROP_YDISTANCE, 28);
   }
   if (ObjectFind("TwoPercent") < 0){
      ObjectCreate("TwoPercent",OBJ_LABEL,1,0,0);
      ObjectSetText("TwoPercent","2%: 0", 10, "Arial", MediumTurquoise);
      ObjectSet("TwoPercent", OBJPROP_CORNER, 0);
      ObjectSet("TwoPercent", OBJPROP_XDISTANCE, 510);
      ObjectSet("TwoPercent", OBJPROP_YDISTANCE, 51);
   }
   
   double Spread = MarketInfo(Symbol(), MODE_SPREAD) / 10;
   color SpreadColor = Orange;
   
   ObjectSetText("Spread","Spread: ", 10, "Arial", LightSteelBlue);
   ObjectSetText("SpreadLabel",DoubleToStr(Spread,1), 10, "Arial", SpreadColor);
   ObjectSetText("BarEnd","Bar Ends: "+barEnd(), 10, "Arial", LightSteelBlue);
   
   // calculate daily range
   double RawDailyRange = 0.0;
   double DailyRange;
   int a = 1;
   while (a <= DailyRangeDays){
      RawDailyRange = RawDailyRange + (MathAbs(iHigh(Symbol(),PERIOD_D1,a) - iLow(Symbol(),PERIOD_D1,a)) / PipPoint(Symbol()));
      a++;
   }
   DailyRange = NormalizeDouble(RawDailyRange / DailyRangeDays,0);
   
   ObjectSetText("DailyRange","Avg Daily Range: "+DoubleToStr(DailyRange,0), 10, "Arial", LightSteelBlue);
   ObjectSetText("DailyRangeDays","("+DailyRangeDays+" Days)", 8, "Arial", LightSteelBlue);
   
   DisplayATR(Symbol());
   
   // trade values
   if ((CurProfitLine > CurEntryLine)&&(CurEntryLine > CurStopLine)){ // looking for longs
      StopPips = NormalizeDouble((CurEntryLine - CurStopLine)/PipPoint(Symbol()),1);
      ProfitPips = NormalizeDouble((CurProfitLine - CurEntryLine)/PipPoint(Symbol()),1);
      OnePercentLot = GetLotSize(Symbol(),1,StopPips);
      TwoPercentLot = GetLotSize(Symbol(),2,StopPips);
      OnePercentMargin = CalculateMarginToOpen(Symbol(),OnePercentLot);
      TwoPercentMargin = CalculateMarginToOpen(Symbol(),TwoPercentLot);
      ObjectSetText("StopSize","Stop Pips: "+DoubleToStr(StopPips,1), 10, "Arial", LightSteelBlue);
      ObjectSetText("ProfitSize","Profit Pips: "+DoubleToStr(ProfitPips,1), 10, "Arial", LightSteelBlue);
      ObjectSetText("TradeRatio","(Approx R/R: "+DoubleToStr(NormalizeDouble((ProfitPips/StopPips),1),1)+" to 1)", 8, "Arial", LightSteelBlue);
      ObjectSetText("OnePercent","1%: "+DoubleToStr(OnePercentLot,2)+"  ("+DoubleToStr(OnePercentMargin,2)+")", 10, "Arial", MediumSeaGreen);
      ObjectSetText("TwoPercent","2%: "+DoubleToStr(TwoPercentLot,2)+"  ("+DoubleToStr(TwoPercentMargin,2)+")", 10, "Arial", MediumSeaGreen);
   } else if ((CurProfitLine < CurEntryLine)&&(CurEntryLine < CurStopLine)){ // looking for shorts
      StopPips = NormalizeDouble((CurStopLine - CurEntryLine)/PipPoint(Symbol()),1);
      ProfitPips = NormalizeDouble((CurEntryLine - CurProfitLine)/PipPoint(Symbol()),1);
      OnePercentLot = GetLotSize(Symbol(),1,StopPips);
      TwoPercentLot = GetLotSize(Symbol(),2,StopPips);
      OnePercentMargin = CalculateMarginToOpen(Symbol(),OnePercentLot);
      TwoPercentMargin = CalculateMarginToOpen(Symbol(),TwoPercentLot);
      ObjectSetText("StopSize","Stop Pips: "+DoubleToStr(StopPips,1), 10, "Arial", LightSteelBlue);
      ObjectSetText("ProfitSize","Profit Pips: "+DoubleToStr(ProfitPips,1), 10, "Arial", LightSteelBlue);
      ObjectSetText("TradeRatio","(Approx R/R: "+DoubleToStr(NormalizeDouble((ProfitPips/StopPips),1),1)+" to 1)", 8, "Arial", LightSteelBlue);
      ObjectSetText("OnePercent","1%: "+DoubleToStr(OnePercentLot,2)+"  ("+DoubleToStr(OnePercentMargin,2)+")", 10, "Arial", MediumSeaGreen);
      ObjectSetText("TwoPercent","2%: "+DoubleToStr(TwoPercentLot,2)+"  ("+DoubleToStr(TwoPercentMargin,2)+")", 10, "Arial", MediumSeaGreen);
   } else {
      ObjectSetText("StopSize","Stop Pips: 0", 10, "Arial", LightSteelBlue);
      ObjectSetText("ProfitSize","Profit Pips: 0", 10, "Arial", LightSteelBlue);
      ObjectSetText("TradeRatio","(Invalid)", 8, "Arial", LightSteelBlue);
      ObjectSetText("OnePercent","1%: 0", 10, "Arial", MediumSeaGreen);
      ObjectSetText("TwoPercent","2%: 0", 10, "Arial", MediumSeaGreen);
   }
      
   
   double p1s5lot = GetLotSize(Symbol(),1,5);
   double p1s5margin = CalculateMarginToOpen(Symbol(),p1s5lot);
   double p1s10lot = GetLotSize(Symbol(),1,10);
   double p1s10margin = CalculateMarginToOpen(Symbol(),p1s10lot);
   double p1s15lot = GetLotSize(Symbol(),1,15);
   double p1s15margin = CalculateMarginToOpen(Symbol(),p1s15lot);
   double p1s20lot = GetLotSize(Symbol(),1,20);
   double p1s20margin = CalculateMarginToOpen(Symbol(),p1s20lot);
   double p2s5lot = GetLotSize(Symbol(),2,5);
   double p2s5margin = CalculateMarginToOpen(Symbol(),p2s5lot);
   double p2s10lot = GetLotSize(Symbol(),2,10);
   double p2s10margin = CalculateMarginToOpen(Symbol(),p2s10lot);
   double p2s15lot = GetLotSize(Symbol(),2,15);
   double p2s15margin = CalculateMarginToOpen(Symbol(),p2s15lot);
   double p2s20lot = GetLotSize(Symbol(),2,20);
   double p2s20margin = CalculateMarginToOpen(Symbol(),p2s20lot);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------+//
//| Calculate pip point for pair             |//
//+------------------------------------------+//
double PipPoint(string Pair){
   double GetDigits = MarketInfo(Pair, MODE_DIGITS);
   double UsePoint;
   if(GetDigits == 2 || GetDigits == 3) UsePoint = 0.01;
   else if(GetDigits == 4 || GetDigits == 5) UsePoint = 0.0001;
   return(UsePoint);
}

//+------------------------------------------+
//| Determine lot size based on defined risk |
//+------------------------------------------+
double GetLotSize ( string pair, double rawrisk, int stopSize )
{
   
   double balance = AccountBalance();
   double pairPrice;
   double usPrice;
   int lotSize;
   double volume;
   double risk = rawrisk * 0.01;
   
   string baseCurrency = StringSubstr(pair,0,3);
   string counterCurrency = StringSubstr(pair,3,3);
   
   if (counterCurrency == "USD") // eg AUDUSDm
   {
      lotSize = balance * risk / stopSize * MarketInfo(pair, MODE_LOTSIZE);
   }
   
   if (baseCurrency == "USD") // eg. USDCADm
   {
      pairPrice = MarketInfo( pair ,MODE_BID);
      lotSize = pairPrice * balance * risk / stopSize * MarketInfo(pair, MODE_LOTSIZE);
   }
   
   if ((counterCurrency != "USD")&&(baseCurrency != "USD"))
   {
      if ((counterCurrency == "CAD") || (counterCurrency == "CHF") || (counterCurrency == "JPY")) // eg. NZDJPYm
      {
         usPrice = MarketInfo( "USD" + counterCurrency + "m" ,MODE_BID);
         lotSize = ((balance * risk) * (usPrice/1)) / stopSize * MarketInfo(pair, MODE_LOTSIZE) / 1;
      }
      else // eg. EURNZDm
      {
         usPrice = MarketInfo( counterCurrency + "USDm" ,MODE_BID);
         lotSize = ((balance * risk) * (1/usPrice)) / stopSize * MarketInfo(pair, MODE_LOTSIZE) / 1;
      }
   }
   
   volume = MathRound(lotSize * 0.01) * 0.01;
   if (counterCurrency == "JPY") volume = MathRound(lotSize * 0.0001) * 0.01; //Account for 3 digits
   
   return (volume);
}

//+-----------------------------------+
//| Calculate Margin to open position |
//+-----------------------------------+
double CalculateMarginToOpen(string Pair, double OrderVolume)
  {
      string First    = StringSubstr(Pair,0,3); // the first symbol, for example,  EUR
      string Second   = StringSubstr(Pair,3,3); // the second symbol, for example, USD
      string Currency = AccountCurrency();        // deposit currency, for example,  USD
      double Leverage = AccountLeverage();        // leverage, for example,          100
      double Contract = MarketInfo(Pair, MODE_LOTSIZE);
      double BidPrice = MarketInfo(Pair, MODE_BID);
 
      // USD Base/Quote
      if(First == Currency)
          return(Contract * OrderVolume / Leverage);            // USDxxx

      if(Second == Currency)  
          return(Contract * BidPrice * OrderVolume / Leverage); // xxxUSD

      // CrossPairs
      string Base = Currency + First + "m";                   // USDxxx
      if(MarketInfo(Base, MODE_BID) > 0)
          return(Contract / MarketInfo(Base, MODE_BID) * OrderVolume / Leverage);

      // Not found try inverse
      Base = First + Currency + "m";                          // xxxUSD
      if(MarketInfo(Base, MODE_BID) > 0) 
          return(Contract * MarketInfo(Base, MODE_BID) * OrderVolume / Leverage);

      // Cannot convert
      Print("MarginCalculate: can not convert "+Pair);
      return(0.0);
}

string barEnd(){
	double g;
   int m,s,k;
   m=Time[0]+Period()*60-CurTime();
   g=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   string M=m, S=s;
   if (m<10)   M="0"+m;
   if (s<10)   S="0"+s;
   
   return(M+":"+S);
}

//+------------------------------------------+//
//| Draw Lines on Chart                      |//
//+------------------------------------------+//
void DrawLine(string Pair, int Type, string Label, datetime Time1, double Price1, datetime Time2, double Price2, int Style, color Color, int Width){
   
   if (ObjectFind(Label) < 0){
      if (Type == OBJ_VLINE){
         ObjectCreate(Label, OBJ_TREND, 0, Time1, 0, Time1, Bid+100);
      } else {
         ObjectCreate(Label, Type, 0, Time1, Price1, Time2, Price2);
      }
      ObjectSet(Label, OBJPROP_COLOR, Color);
      ObjectSet(Label, OBJPROP_STYLE, Style);
      ObjectSet(Label, OBJPROP_WIDTH, Width);
      ObjectSet(Label, OBJPROP_TIMEFRAMES, OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4);
      if (Type == OBJ_TREND){
         ObjectSetText(Label, "Price: "+DoubleToStr(Price1,Digits), 10);
         ObjectSet(Label, OBJPROP_RAY, false);
      }
      if (Label == Beginning_of_Day_Label){
         ObjectSetText(Label, DoubleToStr(GMTOpenHour,0)+":00 GMT");
      }
   } else {
      if ((Type == OBJ_TREND)||(Type == OBJ_HLINE)){
         if ( (ObjectGet(Label, OBJPROP_PRICE1) != Price1) || (ObjectGet(Label, OBJPROP_PRICE2) != Price2)
               || (ObjectGet(Label, OBJPROP_TIME1) != Time1) || (ObjectGet(Label, OBJPROP_TIME2) != Time2) ){
            ObjectSet(Label, OBJPROP_PRICE1, Price1);
            ObjectSet(Label, OBJPROP_PRICE2, Price2);
            ObjectSet(Label, OBJPROP_TIME1, Time1);
            ObjectSet(Label, OBJPROP_TIME2, Time2);
         }
      }
      if (Type == OBJ_VLINE){
         if (ObjectGet(Label, OBJPROP_TIME1) != Time1){
            ObjectSet(Label, OBJPROP_TIME1, Time1);
         }
      }
   }
}
//+------------------------------------------+//
//| Calculate Values for Lines and Time      |//
//+------------------------------------------+//
void CalculateLevels(string Pair,int Timeframe){

   int BeginningOfDayBar,DailyOpenBar, StartBar, EndBar, HighBar, LowBar, DayNumber, BarNumber, BarHour;
   int CurrentDayOfWeek = TimeDayOfWeek(TimeCurrent());
   int CurrentHour = TimeHour(TimeCurrent());
   int CurrentMinute = TimeMinute(TimeCurrent());
   string CurrentDate = TimeYear(TimeCurrent())+"."+TimeMonth(TimeCurrent())+"."+TimeDay(TimeCurrent());
   //string CurrentDate = TimeYear(TimeCurrent())+".04.01";
   
   // get beginning of Day
   BeginningOfDayBar = StrToTime(CurrentDate+" "+GMTOpenHour+":00");
   while (iBarShift(Pair,Timeframe,BeginningOfDayBar,true) < 0){ // Bar does not exist.  Use previous day.
      BeginningOfDayBar = BeginningOfDayBar - 86400;
   }
   
   // get beginning of Previous Day
   int PreviousDayBar = BeginningOfDayBar - 86400;
   while (iBarShift(Pair,Timeframe,PreviousDayBar,true) < 0){ // Bar does not exist.  Use previous day.
      PreviousDayBar = PreviousDayBar - 86400;
   }
   
   // get beginning of Previous Week.  if GMT < 22 use Sunday else use Monday.
   datetime PreviousWeekBegin = iTime(Pair,PERIOD_W1,1)+86400;
   string PreviousWeekBeginTime = TimeYear(PreviousWeekBegin)+"."+TimeMonth(PreviousWeekBegin)+"."+TimeDay(PreviousWeekBegin);
   datetime PreviousWeekBeginBar = StrToTime(PreviousWeekBeginTime+" "+GMTOpenHour+":00");
   int PreviousWeekEndBar = PreviousWeekBeginBar + 601200;
   
   BeginningOfDayData[0] = BeginningOfDayBar;
   BeginningOfDayData[1] = 0;
   
   // get daily Open
   DailyOpenData[0] = BeginningOfDayBar;
   DailyOpenData[1] = iOpen(Pair,PERIOD_H1,iBarShift(Pair,PERIOD_H1,BeginningOfDayBar));
   
   // get previous daily Open
   PreviousDayOpenData[0] = PreviousDayBar;
   PreviousDayOpenData[1] = iOpen(Pair,PERIOD_H1,iBarShift(Pair,PERIOD_H1,PreviousDayBar));
   
   // get previous day High/Low
   EndBar = iBarShift(Pair,PERIOD_M1,PreviousDayBar);
   StartBar = iBarShift(Pair,PERIOD_M1,BeginningOfDayBar);
   
   HighBar = iHighest(Pair,PERIOD_M1,MODE_HIGH,EndBar - StartBar,StartBar);
   LowBar = iLowest(Pair,PERIOD_M1,MODE_LOW,EndBar - StartBar,StartBar);
   PreviousDayHighData[0] = iTime(Pair,PERIOD_M1,HighBar);
   PreviousDayHighData[1] = iHigh(Pair,PERIOD_M1,HighBar);
   PreviousDayLowData[0] = iTime(Pair,PERIOD_M1,LowBar);
   PreviousDayLowData[1] = iLow(Pair,PERIOD_M1,LowBar);
   
   // get previous week Close

   PreviousWeekCloseData[0] = PreviousWeekEndBar+3600;
   PreviousWeekCloseData[1] = iClose(Pair,PERIOD_H1,iBarShift(Pair,PERIOD_H1,PreviousWeekEndBar));
   
   // get previous week Open
   PreviousWeekOpenData[0] = PreviousWeekBeginBar;
   PreviousWeekOpenData[1] = iClose(Pair,PERIOD_H1,iBarShift(Pair,PERIOD_H1,PreviousWeekBeginBar));
   
   // get previous week high/low 
   EndBar = iBarShift(Pair,PERIOD_M1,PreviousWeekBeginBar);
   StartBar = iBarShift(Pair,PERIOD_M1,PreviousWeekEndBar);
   
   HighBar = iHighest(Pair,PERIOD_M1,MODE_HIGH,EndBar - StartBar,StartBar);
   LowBar = iLowest(Pair,PERIOD_M1,MODE_LOW,EndBar - StartBar,StartBar);
   PreviousWeekHighData[0] = iTime(Pair,PERIOD_M1,HighBar);
   PreviousWeekHighData[1] = iHigh(Pair,PERIOD_M1,HighBar);
   PreviousWeekLowData[0] = iTime(Pair,PERIOD_M1,LowBar);
   PreviousWeekLowData[1] = iLow(Pair,PERIOD_M1,LowBar);
   
   // get london Close
   int LondonCloseTime = StrToTime(CurrentDate+" 17:00");
   while (iBarShift(Pair,PERIOD_H1,LondonCloseTime) < 0){
      LondonCloseTime = LondonCloseTime - 86400;
   }
   LondonCloseData[0] = LondonCloseTime;
   LondonCloseData[1] = iClose(Pair,PERIOD_H1,(iBarShift(Pair,PERIOD_H1,LondonCloseTime-3600)));
   /*
   if (TimeDayOfWeek(iOpen(Pair,PERIOD_D1,1)) == 0){
      LondonCloseData[0] = iTime(Pair,PERIOD_D1,2) + 61200;
      LondonCloseData[1] = iClose(Pair,PERIOD_H1,(iBarShift(Pair,PERIOD_H1,LondonCloseData[0]-3600)));
   } else {
      LondonCloseData[0] = iTime(Pair,PERIOD_D1,1) + 61200;
      LondonCloseData[1] = iClose(Pair,PERIOD_H1,(iBarShift(Pair,PERIOD_H1,LondonCloseData[0]-3600)));
   }
   */
   return;
}
//+------------------------------------------+//
//| Draw Big and Mid Figures                 |//
//+------------------------------------------+//
void DrawFigures(string Pair, int NumberFigs){
   double Multiplier,UpperMid,LowerMid,UpperBig,LowerBig;
   double GetDigits = MarketInfo(Pair, MODE_DIGITS);
   if ((GetDigits == 2)||(GetDigits == 3)) Multiplier = 1;
   if ((GetDigits == 4)||(GetDigits == 5)) Multiplier = 100;

   double BigFigUpper = MathCeil(MarketInfo(Pair, MODE_BID) * Multiplier)/Multiplier;
   double BigFigLower = MathFloor(MarketInfo(Pair, MODE_BID) * Multiplier)/Multiplier;
   double MidFigStart = BigFigUpper - (PipPoint(Pair) * 50);
   
   if (Display_Mid_Figure == true){
      DrawLine(Pair, OBJ_HLINE, Mid_Figure_Label+" 0", 0, MidFigStart, 0, 0, Mid_Figure_Style, Mid_Figure_Color, Mid_Figure_Width);
   }
   
   UpperMid = MidFigStart;
   LowerMid = MidFigStart;
   UpperBig = BigFigUpper;
   LowerBig = BigFigLower;
   int a = 0;
   int MidCounter = 1;
   int BigCounter = 1;
   while (a <= NumberFigs){
      UpperMid = UpperMid + (PipPoint(Pair) * 100);
      LowerMid = LowerMid - (PipPoint(Pair) * 100);
      if (Display_Big_Figure == true){
         DrawLine(Pair, OBJ_HLINE, Big_Figure_Label+" "+BigCounter, 0, UpperBig, 0, 0, Big_Figure_Style, Big_Figure_Color, Big_Figure_Width);
         BigCounter++;
         DrawLine(Pair, OBJ_HLINE, Big_Figure_Label+" "+BigCounter, 0, LowerBig, 0, 0, Big_Figure_Style, Big_Figure_Color, Big_Figure_Width);
         BigCounter++;
      }
      if (Display_Mid_Figure == true){
         DrawLine(Pair, OBJ_HLINE, Mid_Figure_Label+" "+MidCounter, 0, UpperMid, 0, 0, Mid_Figure_Style, Mid_Figure_Color, Mid_Figure_Width);
         MidCounter++;
         DrawLine(Pair, OBJ_HLINE, Mid_Figure_Label+" "+MidCounter, 0, LowerMid, 0, 0, Mid_Figure_Style, Mid_Figure_Color, Mid_Figure_Width);
         MidCounter++;
      }
      UpperBig = UpperBig + (PipPoint(Pair) * 100);
      LowerBig = LowerBig - (PipPoint(Pair) * 100);
      a++;
   }
   return;
}

//+------------------------------------------+//
//| Calculate 15%, 20% & 25% of ATR w/ema    |//
//+------------------------------------------+//
void DisplayATR(string Pair){

   string Zero15 = "";
   string Zero20 = "";
   string Zero25 = "";
   
   double ATR1 = iATR(Pair, PERIOD_D1, 5, 0);
   double ATR2 = iATR(Pair, PERIOD_D1, 5, 1);
   double ATR3 = iATR(Pair, PERIOD_D1, 5, 2);
   double ATR4 = iATR(Pair, PERIOD_D1, 5, 3);
   double ATR5 = iATR(Pair, PERIOD_D1, 5, 4);
   double ATR6 = iATR(Pair, PERIOD_D1, 5, 5);
   
   double SMA = (ATR2+ATR3+ATR4+ATR5+ATR6)/5;
   double SMA1 = (ATR1+ATR2+ATR3+ATR4+ATR5)/5;
   double Multiplier = 2.0 / 6;
   double EMA = ((ATR1 - SMA) * Multiplier + SMA);

   Percent15 = NormalizeDouble(EMA/PipPoint(Pair)*0.15,0);
   if (Percent15 < 10) Zero15 = "0";
   Percent20 = NormalizeDouble(EMA/PipPoint(Pair)*0.20,0);
   if (Percent20 < 10) Zero20 = "0";
   Percent25 = NormalizeDouble(EMA/PipPoint(Pair)*0.25,0);
   if (Percent25 < 10) Zero25 = "0";
   
   ObjectSetText("ATR15_Value", Zero15+DoubleToStr(Percent15,0), 10, "Arial", DarkSeaGreen);
   ObjectSetText("ATR20_Value", Zero20+DoubleToStr(Percent20,0), 10, "Arial", DarkSeaGreen);
   ObjectSetText("ATR25_Value", Zero25+DoubleToStr(Percent25,0), 10, "Arial", DarkSeaGreen);
   
   return;
}